;    ZERO648
;      ! 
;     ,      ...
;      

;    ( int0  )     (     )
;         -    .
;          :
;        ,     .
;        ,      .
;      . 



.include 	"tn2313adef.inc"		;  tiny2313a



.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20
.def	Temp5=R21
.def	Temp6=R22
.def	Temp7=R23
.def	Temp8=R24
.def	Temp9=R25


.dseg					; 

key_flag: .byte 1			;  1      "key_flag"


;******************************************************************************
;
;   = 8 
;   = 8
;   (  ) = 64
;   8000000/8/64 = 15625 
;   1/15625=0,000064 
; 3 = 3/0,000064=46875  
;
;


.EQU timer_clock=0xB71B 		;    "timer_clock" = 0xB71B   ( 46875 )


;******************************************************************************

.cseg


.org 0
rjmp RESET				; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset
					;  


.org INT0addr				; = 0x0001 External Interrupt Request 0
rjmp INT_0				;  INT0


.org   OC1Aaddr				; (=0x0004) Timer/Counter1 Compare Match A
rjmp OCR1A_COMP				;    


.org INT_VECTORS_SIZE			;   


;******************************************************************************
;
;******************************************************************************

reset:					;  

	cli				;    


	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;




INIT_ports:
	
	ldi Temp,0b00000110		;   "" ( 0-, 1- )
	out DDRB,Temp			; 000000 - "" 
					; ( PB1 - 13  -   ) 
					; ( PB2 - 14  -   )
	

	ldi Temp,0b00000000		;  _0   ! (  ,   !!! )
	out PortB,Temp			; 
																						 



INIT_ext_int:

	ldi Temp, (1<<ISC00)		;      INT0    
	out MCUCR,Temp			;      !


	ldi Temp,(1<<INT0)		;     INT0
	out GIMSK ,Temp

	in  Temp, EIFR			;   *************************************************
	out EIFR ,Temp






Timer1_Init:

	LDI Temp,high(timer_clock)	;    
	OUT OCR1AH,Temp			;      
	LDI Temp,low(timer_clock)							
	OUT OCR1AL,Temp       



;	ldi Temp, 0			;     (   )
;	out TCCR1A,Temp			; (0<<COM1A1)|(0<<COM1A0)|(0<<COM1B1)|(0<<COM1B0)|(0<<wgm11)|(0<<wgm10)


					
;	ldi Temp,(0<<CS11)|(0<<CS10)	;    = CK 0:0 
;	out TCCR1B,Temp			;  !

			

	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp


	ldi Temp,(1<<OCIE1A)		;    
	out TIMSK,Temp
	


; 

	LDI Temp, 0			; Temp=0 (   _  )
	STS key_flag, Temp		;   "key_flag"   "Temp"



	sei				;   
        



;*******************************************************************************
;  
;*******************************************************************************


Main_cicle:




	LDS Temp, key_flag		;  ()   "key_flag"  "Temp"
	cpi Temp, 0			;      
	breq Main_cicle			;    ,     
					;     





	ldi Temp,0b00000010		;  ,  .
	out PortB,Temp			; 
					; ( PB1 - 13  -   ) 
					; ( PB2 - 14  -   )
											



	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp



	ldi Temp,(1<<CS11)|(1<<CS10)	;    = CK 1:64 
	out TCCR1B,Temp			;   !


circular_cycle:

	LDS Temp, key_flag		;  ()   "key_flag"  "Temp"
	cpi Temp, 0			;      
	breq Main_cicle			;    ,     
					;   .


	rjmp circular_cycle		;  




;*******************************************************************************
;     
;*******************************************************************************

OCR1A_COMP:


	in temp4,SREG			;    "SREG"/////////////////////////////////////////////////////
	push temp4

;********************************************************************************

	cpi Temp, 1			;    (   )
	brne svarka_off			;     -  

;******************************************************************************

svarka_on:				;  

	LDI Temp, 0			; Temp=0 (    )
	STS key_flag, Temp		;   "key_flag"   "Temp"


	ldi Temp,0b00000110		;  
	out PortB,Temp			; 
					; ( PB1 - 13  -   ) 
					; ( PB2 - 14  -   )


											
	ldi Temp,(0<<CS11)|(0<<CS10)	;    = CK 0:0
	out TCCR1B,Temp			;  !


	rjmp out_1			;   


;********************************************************************************


svarka_off:				;  

	LDI Temp, 0			; Temp=0 (    )
	STS key_flag, Temp		;   "key_flag"   "Temp"


	ldi Temp,0b00000000		;  
	out PortB,Temp			; 
					; ( PB1 - 13  -   ) 
					; ( PB2 - 14  -   )
											


	ldi Temp,(0<<CS11)|(0<<CS10)	;    = CK 0:0
	out TCCR1B,Temp			;  !


	rjmp out_1			;   


;********************************************************************************









;*******************************************************************************
;   INT0
;*******************************************************************************

INT_0:


	in temp4,SREG			;    "SREG"/////////////////////////////////////////////////////
	push temp4


;********************************************************************************

	
					; sbis =   ,   "0"   "" .
	sbis PIND, 2			;        ? (   ??? )
	rjmp set_falling_edge		;  ,     "   "


;********************************************************************************

;  			;    
;					;   (   )



	LDI Temp, 2			; Temp=2 (  ,       )
	STS key_flag, Temp		;   "key_flag"   "Temp"


	rjmp out_1






;  
;
set_falling_edge:			;    
					;   (   )	


	LDI Temp, 1			; Temp=1 (  ,       )
	STS key_flag, Temp		;   "key_flag"   "Temp"


	rjmp out_1




;**************************************************************************************************************
;   
;**************************************************************************************************************

out_1:	

	

	pop temp4			;     "SREG" ////////////////////////////////////////////////////
	out SREG, temp4

	RETI				;    



